unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Menus;

type
  TForm1 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    FilterComboBox1: TFilterComboBox;
    Button1: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure FilterComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{$I-}

procedure TForm1.DriveComboBox1Change(Sender: TObject);
begin
 DirectoryListBox1.Drive := DriveComboBox1.Drive;
 FileListBox1.Drive := DriveComboBox1.Drive;
 FileListBox1.Directory := DirectoryListBox1.Directory;
end;

procedure TForm1.FilterComboBox1Change(Sender: TObject);
begin
  FileListBox1.Mask := FilterComboBox1.Mask;
  FileListBox1.Drive := DriveComboBox1.Drive;
  FileListBox1.Directory := DirectoryListBox1.Directory;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 FilterComboBox1.Filter := '  (*.txt)|*.txt|   (*.*)|*.*';
 PopupMenu1.AutoPopup := True;
 FileListBox1.PopupMenu := PopupMenu2;
end;

procedure TForm1.DirectoryListBox1Change(Sender: TObject);
begin
  FileListBox1.Mask := FilterComboBox1.Mask;
  FileListBox1.Drive := DriveComboBox1.Drive;
  FileListBox1.Directory := DirectoryListBox1.Directory;
end;

function TypeHeader (var Name:String; var w:TextFile):integer; {}
var Found:integer;
    s:String;
    f:TextFile;
begin
 Found:=0;
 assignfile(f,Name);
 reset(f);
 if IoResult=0 then begin
  write (w,''+#9+''+#9);
  while not Eof(f) do begin
   Readln (f,s);
   if (Pos (':',s)>0) then begin
    Inc(Found);
    If (Found>2) Then begin
     write (w,Copy(s,1,Pos (':',s))+#9);
    End;
   End;
  End;
  Writeln (w);
  Form1.Memo1.Lines.Add(' ');
  TypeHeader:=0;
 end
 else begin
  Form1.Memo1.Lines.Add('   !');
  TypeHeader:=1;
 end;
 closefile (f);
end;

procedure TForm1.Button1Click(Sender: TObject);
var SearchRec: TSearchRec;
    s,n,line:String;
    r,Files,Lines,Number,Code,Error,Errors,Found:Integer;
    f,w:TextFile;
begin
 Memo1.Lines.Clear;
 s:=FileListBox1.Directory+'\'+Edit1.Text;
 assignfile(w,s);
 rewrite(w);

 if (IOResult<>0) Then Begin
  Memo1.Lines.Add('         '+s+'      ');
  Exit;
 End;

 s:=FileListBox1.Directory+'\'+FileListBox1.Mask;
 Memo1.Lines.Add(' :');
 Memo1.Lines.Add(s+#13);
 Files:=0;
 Error:=0;
 r:=FindFirst(s, faAnyFile, SearchRec);
 if (r=0) then begin
   repeat
    if (SearchRec.Name=Edit1.Text) then continue;
    if (Files=0) then Errors:=TypeHeader (SearchRec.Name,w);
    line:=SearchRec.Name+': ';
    Inc(Files);
    {$I-}
    assignfile(f,SearchRec.Name);
    reset(f);
    if (IOResult<>0) Then Begin
     line:=line+' !';
     Error:=1; Inc(Errors);
    End
    else begin
     Lines:=0;
     Found:=0;
     while not Eof(f) do begin
      Readln (f,s);
      if (IOResult<>0) Then Begin
       line:=line+'  !';
       Error:=2; Inc(Errors);
       break;
      End;
      Inc (Lines);
      if (Pos (':',s)>0) then begin
       n:=Copy(s,Pos (':',s)+1,Length(s));
       Val(n, Number, Code);
       if Code <> 0 then begin
        If (Found=0) then begin {}
         write(w,Files); {}
         write (w,#9);
         write (w,n+#9);
         Inc(Found);
        end
        else if (Found>9) then begin {}
         line:=line+'   !';
         Error:=3; Inc(Errors);
         break;
        end
       end
       else begin
        write (w,Number);
        write (w,#9);
        Inc(Found);
       end;
      end;
     End;
     writeln (w);
     if Error=0 then begin
      Str (Lines,n);
      line:=line+' ('+n+' .)';
     End;
     Memo1.Lines.Add(line);
     CloseFile (f);
    End;
   until  (FindNext(SearchRec) <> 0);
   if Files>0 Then begin
    Str (Files,n);
    Memo1.Lines.Add(' :'+n);
    Str (Errors,n);
    Memo1.Lines.Add(':'+n);
   end;
 end;
 CloseFile (w);
 if (Files=0) then begin
  Erase (w);
  Memo1.Lines.Add('     '+FileListBox1.Mask+'   .  .');
 end;

end;

procedure TForm1.N1Click(Sender: TObject);      {  }
var s:String;
begin
 if FileExists(FileListBox1.FileName) then begin
  s:='  ' + ExtractFileName(FileListBox1.FileName)+'?';
  if Application.MessageBox(PChar(s),' ', MB_OKCANCEL) = IdOK
   then
    if not DeleteFile(FileListBox1.FileName) then
    Application.MessageBox('   ! ,      !',' !',MB_OK);
 end;
 FileListBox1.Update;
end;

procedure TForm1.N2Click(Sender: TObject); {  }
var NewName:String;
begin
 if FileExists(FileListBox1.FileName) then begin
  NewName:= InputBox('', '    '+
   ExtractFileName(FileListBox1.FileName), '');
  if not RenameFile(FileListBox1.FileName,NewName) then
   Application.MessageBox('   ! ,      !',' !',MB_OK);
 end;
 FileListBox1.Update;
end;

procedure TForm1.N3Click(Sender: TObject); {   }
begin
 FileListBox1.Update;
end;

end.
